#include <fstream>
#include <cstring>
#include <algorithm>

using namespace std;

const int Nmax = 1000005;

char a[Nmax], b[Nmax];
int n, m, maxnr[Nmax], need[26], have[26], nr_chars, have_chars, ans;

int getPos(int pos, char b[])
{
    int cur = 1;
    while(pos <= n && cur <= m)
    {
        if(a[pos] == b[cur])
            ++cur;
        if(cur == m + 1)
            return pos + 1;
        ++pos;
    }
    return -1;
}

int main()
{
    ifstream cin("anagrame.in");
    ofstream cout("anagrame.out");

    cin >> a + 1 >> b + 1;
    n = strlen(a + 1);
    m = strlen(b + 1);

    for(int i = 1; i <= m; i++)
        if(++need[b[i] - 'a'] == 1)
            ++nr_chars;

    for(int i = n; i; i--)
    {
        if(++have[a[i] - 'a'] == need[a[i] - 'a'])
            ++have_chars;
        if(have_chars == nr_chars)
        {
            ++ans;
            for(int i = 0; i < 26; i++)
                have[i] = 0;
            have_chars = 0;
        }
        maxnr[i] = ans;
    }

    cout << ans << "\n";

    int pos = 1, nr_left = ans;
    while(pos <= n)
    {
        sort(b + 1, b + m + 1);
        do
        {
            int x = getPos(pos, b);
            if(x == -1 || maxnr[x] != nr_left - 1)
                continue;
            for(int i = 1; i <= m; i++)
                cout << b[i];
            pos = x;
            --nr_left;
            break;
        }
        while(next_permutation(b + 1, b + m + 1));
    }
    cout << "\n";
    return 0;
}
