#include <vector>
#include <string>
#include <fstream>
using namespace std;
struct cos1{

bool haveAnagram(vector<int> &fStart, vector<int> &fEnd, vector<int> &f) {
    for (int i = 0; i < f.size(); i++) {
        if (fStart[i] - fEnd[i] < f[i]) return false;
    }
    return true;
}

int solve() {
    ifstream            f("anagrame.in");
    ofstream            g("anagrame.out");
    int                 P;
    string              A, B; f >> P >> A >> B;
    vector<vector<int>> pos(26);
    vector<int>         freqB(26);
    vector<vector<int>> freq(A.size() + 1, vector<int>(26));
    vector<int>         len(A.size() + 1);
    string              ans = "";

    for (char c : B) freqB[c - 'a']++;

    int last = (int)A.size();
    len[A.size()] = 0;
    for (int i = (int)A.size() - 1; i >= 0; i--) {
        pos[A[i] - 'a'].push_back(i);
        freq[i] = freq[i + 1]; freq[i][A[i] - 'a']++;
        if (haveAnagram(freq[i], freq[last], freqB)) {
            len[i] = 1 + len[i + 1];
            last   = i;
        }
        else len[i] = len[last];
    }

    for (int cnt = len[0], i = 0, j = 0; cnt; cnt--) {
        vector<int> f = freqB;

        for (; j < A.size() && len[j] >= cnt - 1; j++);
        if (j != A.size()) j--;

        for (int steps = 0; steps < B.size(); steps++) {
            for (int k = 0; k < freqB.size(); k++) {
                if (!f[k])  continue;
                int p = *pos[k].rbegin();
                if (p >= j) continue;

                if (haveAnagram(freq[p], freq[j], f)) {
                    i = p; break;
                }
            }

            ans.push_back(A[i]);
            f[A[i] - 'a']--;
            i++;

            for (int k = 0; k < freqB.size(); k++) {
                while (!pos[k].empty() && *pos[k].rbegin() < i) {
                    pos[k].pop_back();
                }
            }
        }
    }

    if(P==2) g << ans <<"\n";
    else g << (int)ans.size()/(int)B.size() << "\n";

    return 0;
}
}a1;
int main(){
    a1.solve();
    return 0;
}

